CS 188 Introduction To Artificial Intelligence Spring 2019 Note 1
CS 188 Introduction To Artificial Intelligence Spring 2019 Note 1
CS 188 Introduction To Artificial Intelligence Spring 2019 Note 1
Agents
In artificial intelligence, the central problem at hand is that of the creation of a rational agent, an entity that
has goals or preferences and tries to perform a series of actions that yield the best/optimal expected outcome
given these goals. Rational agents exist in an environment, which is specific to the given instantiation of
the agent. As a very simple example, the environment for a checkers agent is the virtual checkers board on
which it plays against opponents, where piece moves are actions. Together, an environment and the agents
that reside within it create a world.
A reflex agent is one that doesn’t think about the consequences of its actions, but rather selects an action
based solely on the current state of the world. These agents are typically outperformed by planning agents,
which maintain a model of the world and use this model to simulate performing various actions. Then, the
agent can determine hypothesized consequences of the actions and can select the best one. This is simulated
"intelligence" in the sense that it’s exactly what humans do when trying to determine the best possible move
in any situation - thinking ahead.
• A state space - The set of all possible states that are possible in your given world
• A successor function - A function that takes in a state and an action and computes the cost of per-
forming that action as well as the successor state, the state the world would be in if the given agent
performed that action
• A start state - The state in which an agent exists initially
• A goal test - A function that takes a state as input, and determines whether it is a goal state
Fundamentally, a search problem is solved by first considering the start state, then exploring the state space
using the successor function, iteratively computing successors of various states until we arrive at a goal state,
at which point we will have determined a path from the start state to the goal state (typically called a plan).
The order in which states are considered is determined using a predetermined strategy. We’ll cover types
of strategies and their usefulness shortly.
Before we continue with how to solve search problems, it’s important to note the difference between a world
state, and a search state. A world state contains all information about a given state, whereas a search state
Let’s consider a variation of the game in which the maze contains only Pacman and food pellets. We can
pose two distinct search problems in this scenario: pathing and eat-all-dots. Pathing attempts to solve
the problem of getting from position (x1 , y1 ) to position (x2 , y2 ) in the maze optimally, while eat all dots
attempts to solve the problem of consuming all food pellets in the maze in the shortest time possible. Below,
the states, actions, successor function, and goal test for both problems are listed:
• Pathing • Eat-all-dots
Note that for pathing, states contain less information than states for eat-all-dots, because for eat-all-dots we
must maintain an array of booleans corresponding to each food pellet and whether or not it’s been eaten in
the given state. A world state may contain more information still, potentially encoding information about
things like total distance traveled by Pacman or all positions visited by Pacman on top of its current (x,y)
location and dot booleans.
• Pacman positions - Pacman can be in 120 distinct (x, y) positions, and there is only one Pacman
• Pacman Direction - this can be North, South, East, or West, for a total of 4 possibilities
• Ghost positions - There are two ghosts, each of which can be in 12 distinct (x, y) positions
• Food pellet configurations - There are 30 food pellets, each of which can be eaten or not eaten
Using the fundamental counting principle, we have 120 positions for Pacman, 4 directions Pacman can be
facing, 12 · 12 ghost configurations (12 for each ghost), and 2 · 2 · ... · 2 = 230 food pellet configurations (each
of 30 food pellets has two possible values - eaten or not eaten). This gives us a total state space size of
120 · 4 · 122 · 230 .
Uninformed Search
The standard protocol for finding a plan to get from the start state to a goal state is to maintain an outer
fringe of partial plans derived from the search tree. We continually expand our fringe by removing a node
(which is selected using our given strategy) corresponding to a partial plan from the fringe, and replacing
it on the fringe with all its children. Removing and replacing an element on the fringe with its children
corresponds to discarding a single length n plan and bringing all length (n + 1) plans that stem from it into
consideration. We continue this until eventually removing a goal state off the fringe, at which point we
conclude the partial plan corresponding to the removed goal state is in fact a path to get from the start state
to the goal state. Practically, most implementations of such algorithms will encode information about the
parent node, distance to node, and the state inside the node object. This procedure we have just outlined is
known as tree search, and the pseudocode for it is presented below:
• The completeness of each search strategy - if there exists a solution to the search problem, is the
strategy guaranteed to find it given infinite computational resources?
• The optimality of each search strategy - is the strategy guaranteed to find the lowest cost path to a
goal state?
• The branching factor b - The increase in the number of nodes on the fringe each time a fringe node
is dequeued and replaced with its children is O(b). At depth k in the search tree, there exists O(bk )
nodes.
• The maximum depth m.
• The depth of the shallowest solution s.
Depth-First Search
• Description - Depth-first search (DFS) is a strategy for exploration that always selects the deepest
fringe node from the start node for expansion.
• Fringe representation - Removing the deepest node and replacing it on the fringe with its children
necessarily means the children are now the new deepest nodes - their depth is one greater than the
depth of the previous deepest node. This implies that to implement DFS, we require a structure that
always gives the most recently added objects highest priority. A last-in, first-out (LIFO) stack does
exactly this, and is what is traditionally used to represent the fringe when implementing DFS.
• Optimality - Depth-first search simply finds the "leftmost" solution in the search tree without regard
for path costs, and so is not optimal.
• Time Complexity - In the worst case, depth first search may end up exploring the entire search tree.
Hence, given a tree with maximum depth m, the runtime of DFS is O(bm ).
• Space Complexity - In the worst case, DFS maintains b nodes at each of m depth levels on the fringe.
This is a simple consequence of the fact that once b children of some parent are enqueued, the nature
of DFS allows only one of the subtrees of any of these children to be explored at any given point in
time. Hence, the space complexity of DFS is O(bm).
Breadth-First Search
• Description - Breadth-first search is a strategy for exploration that always selects the shallowest fringe
node from the start node for expansion.
• Fringe representation - If we want to visit shallower nodes before deeper nodes, we must visit nodes
in their order of insertion. Hence, we desire a structure that outputs the oldest enqueued object to
represent our fringe. For this, BFS uses a first-in, first-out (FIFO) queue, which does exactly this.
• Completeness - If a solution exists, then the depth of the shallowest node s must be finite, so BFS
must eventually search this depth. Hence, it’s complete.
• Optimality - BFS is generally not optimal because it simply does not take costs into consideration
when determining which node to replace on the fringe. The special case where BFS is guaranteed to
be optimal is if all edge costs are equivalent, because this reduces BFS to a special case of uniform
cost search, which is discussed below.
• Time Complexity - We must search 1 + b + b2 + ... + bs nodes in the worst case, since we go through
all nodes at every depth from 1 to s. Hence, the time complexity is O(bs ).
• Space Complexity - The fringe, in the worst case, contains all the nodes in the level corresponding to
the shallowest solution. Since the shallowest solution is located at depth s, there are O(bs ) nodes at
this depth.
• Fringe representation - To represent the fringe for UCS, the choice is usually a heap-based priority
queue, where the weight for a given enqueued node v is the path cost from the start node to v, or the
backward cost of v. Intuitively, a priority queue constructed in this manner simply reshuffles itself to
maintain the desired ordering by path cost as we remove the current minimum cost path and replace
it with its children.
• Completeness - Uniform cost search is complete. If a goal state exists, it must have some finite length
shortest path; hence, UCS must eventually find this shortest length path.
• Optimality - UCS is also optimal if we assume all edge costs are nonnegative. By construction, since
we explore nodes in order of increasing path cost, we’re guaranteed to find the lowest-cost path to a
goal state. The strategy employed in Uniform Cost Search is identical to that of Dijkstra’s algorithm,
and the chief difference is that UCS terminates upon finding a solution state instead of finding the
shortest path to all states. Note that having negative edge costs in our graph can make nodes on a
path have decreasing length, ruining our guarantee of optimality. (See Bellman-Ford algorithm for a
slower algorithm that handles this possibility)
• Time Complexity - Let us define the optimal path cost as C∗ and the minimal cost between two nodes
in the state space graph as ε. Then, we must roughly explore all nodes at depths ranging from 1 to
∗
C∗ /ε, leading to an runtime of O(bC /ε ).
• Space Complexity - Roughly, the fringe will contain all nodes at the level of the cheapest solution, so
∗
the space complexity of UCS is estimated as O(bC /ε ).
As a parting note about uninformed search, it’s critical to note that the three strategies outlined above are
fundamentally the same - differing only in expansion strategy, with their similarities being captured by the
tree search pseudocode presented above.
Informed Search
Uniform cost search is good because it’s both complete and optimal, but it can be fairly slow because it
expands in every direction from the start state while searching for a goal. If we have some notion of the
direction in which we should focus our search, we can significantly improve performance and "hone in" on
a goal much more quickly. This is exactly the focus of informed search.
The above visualization shows the relaxed problem that the Manhattan distance helps solve - assuming
Pacman desires to get to the bottom left corner of the maze, it computes the distance from Pacman’s current
location to Pacman’s desired location assuming a lack of walls in the maze. This distance is the exact goal
distance in the relaxed search problem, and correspondingly is the estimated goal distance in the actual
search problem. With heuristics, it becomes very easy to implement logic in our agent that enables them
to "prefer" expanding states that are estimated to be closer to goal states when deciding which action to
perform. This concept of preference is very powerful, and is utilized by the following two search algorithms
that implement heuristic functions: greedy search and A*.
Greedy Search
• Description - Greedy search is a strategy for exploration that always selects the fringe node with the
lowest heuristic value for expansion, which corresponds to the state it believes is nearest to a goal.
• Fringe representation - Greedy search operates identically to UCS, with a priority queue fringe rep-
resentation. The difference is that instead of using computed backward cost (the sum of edge weights
in the path to the state) to assign priority, greedy search uses estimated forward cost in the form of
heuristic values.
• Completeness and Optimality - Greedy search is not guaranteed to find a goal state if one exists, nor is
it optimal, particularly in cases where a very bad heuristic function is selected. It generally acts fairly
unpredictably from scenario to scenario, and can range from going straight to a goal state to acting
like a badly-guided DFS and exploring all the wrong areas.
A* Search
• Description - A* search is a strategy for exploration that always selects the fringe node with the lowest
estimated total cost for expansion, where total cost is the entire cost from the start node to the goal
node.
• Fringe representation - Just like greedy search and UCS, A* search also uses a priority queue to
represent its fringe. Again, the only difference is the method of priority selection. A* combines the
total backward cost (sum of edge weights in the path to the state) used by UCS with the estimated
forward cost (heuristic value) used by greedy search by adding these two values, effectively yielding
an estimated total cost from start to goal. Given that we want to minimize the total cost from start to
goal, this is an excellent choice.
• Completeness and Optimality - A* search is both complete and optimal, given an appropriate heuristic
(which we’ll cover in a minute). It’s a combination of the good from all the other search strategies
we’ve covered so far, incorporating the generally high speed of greedy search with the optimality and
completeness of UCS!
• h(n) - The heuristic value function, or estimated forward cost, used by greedy search.
• f (n) - The function representing estimated total cost, used by A* search. f (n) = g(n) + h(n).
Before attacking the question of what constitutes a "good" heuristic, we must first answer the question of
whether A* maintains its properties of completeness and optimality regardless of the heuristic function we
use. Indeed, it’s very easy to find heuristics that break these two coveted properties. As an example, consider
the heuristic function h(n) = 1 − g(n). Regardless of the search problem, using this heuristic yields
Hence, such a heuristic reduces A* search to BFS, where all edge costs are equivalent. As we’ve already
shown, BFS is not guaranteed to be optimal in the general case where edge weights are not constant.
The condition required for optimality when using A* tree search is known as admissibility. The admissi-
bility constraint states that the value estimated by an admissible heuristic is neither negative nor an overes-
timate. Defining h∗ (n) as the true optimal forward cost to reach a goal state from a given node n, we can
formulate the admissibility constraint mathematically as follows:
1. g(A) < g(B). Because A is given to be optimal and B is given to be suboptimal, we can conclude that
A has a lower backwards cost to the start state than B.
2. h(A) = h(B) = 0, because we are given that our heuristic satisfies the admissibility constraint. Since
both A and B are both goal states, the true optimal cost to a goal state from A or B is simply h∗ (n) = 0;
hence 0 ≤ h(n) ≤ 0.
3. f (n) ≤ f (A), because, through admissibility of h, f (n) = g(n) + h(n) ≤ g(n) + h∗ (n) = g(A) = f (A).
The total cost through node n is at most the true backward cost of A, which is also the total cost of A.
We can combine statements 1. and 2. to conclude that f (A) < f (B) as follows:
A simple consequence of combining the above derived inequality with statement 3. is the following:
Hence, we can conclude that n is expanded before B. Because we have proven this for arbitrary n, we can
conclude that all ancestors of A (including A itself) expand before B. 2
One problem we found above with tree search was that in some cases it could fail to ever find a solution,
getting stuck searching the same cycle in the state space graph infinitely. Even in situations where our
search technique doesn’t involve such an infinite loop, it’s often the case that we revisit the same node
multiple times because there’s multiple ways to get to that same node. This leads to exponentially more
work, and the natural solution is to simply keep track of which states you’ve already expanded, and never
expand them again. More explicitly, maintain a "closed" set of expanded nodes while utilizing your search
method of choice. Then, ensure that each node isn’t already in the set before expansion and add it to the
set after expansion if it’s not. Tree search with this added optimization is known as graph search, and the
pseudocode for it is presented below:
In the above example, it’s clear that the optimal route is to follow S → A → C → G, yielding a total path cost
of 1 + 1 + 3 = 5. The only other path to the goal, S → B → C → G has a path cost of 1 + 2 + 3 = 6. However,
because the heuristic value of node A is so much larger than the heuristic value of node B, node C is first
expanded along the second, suboptimal path as a child of node B. It’s then placed into the "closed" set, and
so A* graph search fails to reexpand it when it visits it as a child of A, so it never finds the optimal solution.
Hence, to maintain completeness and optimality under A* graph search, we need an even stronger property
than admissibility, consistency. The central idea of consistency is that we enforce not only that a heuristic
underestimates the total distance to a goal from any given node, but also the cost/weight of each edge in the
graph. The cost of an edge as measured by the heuristic function is simply the difference in heuristic values
for two connected nodes. Mathematically, the consistency constraint can be expressed as follows:
∀A,C h(A) − h(C) ≤ cost(A,C)
Theorem. For a given search problem, if the consistency constraint is satisfied by a heuristic function h,
using A* graph search with h on that search problem will yield an optimal solution.
Proof. In order to prove the above theorem, we first prove that when running A* graph search with a
consistent heuristic, whenever we remove a node for expansion, we’ve found the optimal path to that node.
Using the consistency constraint, we can show that the values of f (n) for nodes along any plan are nonde-
creasing. Define two nodes, n and n0 , where n0 is a successor of n. Then:
If for every parent-child pair (n, n0 ) along a path, f (n0 ) ≥ f (n), then it must be the case that the values of
f (n) are nondecreasing along that path. We can check that the above graph violates this rule between f (A)
just as in our proof of optimality of A* tree search under the admissibility constraint. Hence, we can
conclude that A* graph search is optimal under a consistent heuristic. 2
A couple of important highlights from the discussion above before we proceed: for heuristics that are either
admissible/consistent to be valid, it must by definition be the case that h(G) = 0 for any goal state G. Ad-
ditionally, consistency is not just a stronger constraint than admissibility, consistency implies admissibility.
This stems simply from the fact that if no edge costs are overestimates (as guaranteed by consistency), the
total estimated cost from any node to a goal will also fail to be an overestimate.
Consider the following three-node network for an example of an admissible but inconsistent heuristic:
The red dotted line corresponds to the total estimated goal distance. If h(A) = 4, then the heuristic is
admissible, as the distance from A to the goal is 4 ≥ h(A), and same for h(C) = 1 ≤ 3. However, the
heuristic cost from A to C is h(A) − h(C) = 4 − 1 = 3. Our heuristic estimates the cost of the edge between
A and C to be 3 while the true value is cost(A,C) = 1, a smaller value. Since h(A) − h(C) cost(A,C),
this heuristic is not consistent. Running the same computation for h(A) = 2, however, yields h(A) − h(C) =
2 − 1 = 1 ≤ cost(A,C). Thus, using h(A) = 2 makes our heuristic consistent.
Dominance
Now that we’ve established the properties of admissibility and consistency and their roles in maintaining
the optimality of A* search, we can return to our original problem of creating "good" heuristics, and how to
tell if one heuristic is better than another. The standard metric for this is that of dominance. If heuristic a is
dominant over heuristic b, then the estimated goal distance for a is greater than the estimated goal distance
for b for every node in the state space graph. Mathematically,
∀n : ha (n) ≥ hb (n)
As a general rule, the max function applied to multiple admissible heuristics will also always be admissible.
This is simply a consequence of all values output by the heuristics for any given state being constrained by
the admissibility condition, 0 ≤ h(n) ≤ h∗ (n). The maximum of numbers in this range must also fall in the
same range. The same can be shown easily for multiple consistent heuristics as well. It’s common practice
to generate multiple admissible/consistent heuristics for any given search problem and compute the max
over the values output by them to generate a heuristic that dominates (and hence is better than) all of them
individually.
Summary
In this note, we discussed search problems, which we characterize formally with four components: a state
space, a successor function, a start state, and a goal state. Search problems can be solved using a variety of
search techniques, including but not limited to the five we study in CS 188:
• Breadth-first Search
• Depth-first Search
• Greedy Search
• A* Search
The first three search techniques listed above are examples of uninformed search, while the latter two are
examples of informed search which use heuristics to estimate goal distance and optimize performance.